﻿ Partial Public Class App
    Inherits Application

    public Sub New()
        InitializeComponent()
    End Sub
    
    Private Sub Application_Startup(ByVal o As Object, ByVal e As StartupEventArgs) Handles Me.Startup
        Me.RootVisual = New MainPage()
    End Sub
    
    Private Sub Application_Exit(ByVal o As Object, ByVal e As EventArgs) Handles Me.Exit

    End Sub
    
    Private Sub Application_UnhandledException(ByVal sender As object, ByVal e As ApplicationUnhandledExceptionEventArgs) Handles Me.UnhandledException

        ' Se l'applicazione è in esecuzione all'esterno del debugger, segnalare l'eccezione mediante
        ' il meccanismo di eccezioni del browser. In IE verrà visualizzato un messaggio di avviso di colore giallo 
        ' un'icona nella barra di stato e in Firefox verrà visualizzato un errore di script.
        If Not System.Diagnostics.Debugger.IsAttached Then

            ' NOTA: in questo modo sarà possibile continuare l'esecuzione di un'applicazione dopo la generazione di un'eccezione
            ' ma non gestita. 
            ' Per le applicazioni di produzione la gestione degli errori deve essere sostituita da un meccanismo che 
            ' segnala l'errore al sito Web e interrompe l'applicazione.
            e.Handled = True
            Deployment.Current.Dispatcher.BeginInvoke(New Action(Of ApplicationUnhandledExceptionEventArgs)(AddressOf ReportErrorToDOM), e)
        End If
    End Sub

   Private Sub ReportErrorToDOM(ByVal e As ApplicationUnhandledExceptionEventArgs)

        Try
            Dim errorMsg As String = e.ExceptionObject.Message + e.ExceptionObject.StackTrace
            errorMsg = errorMsg.Replace(""""c, "'"c).Replace(ChrW(13) & ChrW(10), "\n")

            System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(""Unhandled Error in Silverlight Application " + errorMsg + """);")
        Catch
        
        End Try
    End Sub
    
End Class
